Debian GNU/Linux

Booting linux crashes on 2009 White Macbook (hardware version ID "MacBook5,2") unless you use acpi=off or maxcpus=1

Reported by Silvio Sisto on 2009-03-11
86
This bug affects 12 people
Affects Status Importance Assigned to Milestone
Mactel Support
Undecided
Unassigned
acpi
Expired
Unknown
linux (Ubuntu)
Undecided
Unassigned
linux-latest-2.6 (Debian)
New
Undecided
Unassigned

Bug Description

Binary package hint: linux-image-2.6.27-11-generic

The Macbook won't boot unless I use the acpi=off boot option.

I am using Ubuntu 8.10 Intrepid Ibex with kernel 2.6.27.11 x86 generic.
The machine's Hardware version id is Macbook5,2.
It is one of the new early 2009 white macbooks with geforce 9400 video.

I suspect this is the cause why Ubuntu won't show battery status and won't allow me to change screen brightness.
I followed the steps described here [1] and was able to solve most problems (thanks!) with the exception of the previously mentioned.

[1] https://help.ubuntu.com/community/MacBook5-1/Intrepid
Note: Not sure if the package is the right one. If it is wrong please change it.

ProblemType: Bug
Architecture: i386
DistroRelease: Ubuntu 8.10
NonfreeKernelModules: nvidia
Package: linux-image-2.6.27-11-generic 2.6.27-11.27
ProcCmdLine: root=UUID=3f0132f8-e92c-4796-9721-768d4bbfa1f5 ro quiet splash acpi=off
ProcEnviron:
 PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:/usr/games
 LANG=en_US.UTF-8
 SHELL=/bin/bash
ProcVersionSignature: Ubuntu 2.6.27-11.27-generic
SourcePackage: linux

Silvio Sisto (sistoviejo) wrote :
Silvio Sisto (sistoviejo) wrote :

Added information: I have tried the nvidia restricted module version 177 and version 180.
Right now I am using version 180.
Another issue I have is that when I shut down the computer it won't halt.
It stays On with a blank screen and a blinking cursor. I have to shut it down forcefully.
Thanks for reading.

ste (dummy-it) wrote :

i have the same problems with the same macbook 5,2 :)

Silvio Sisto (sistoviejo) wrote :

These are other issues I forgot to mention that might be related.
When I check /proc/cpuinfo it reports the CPU as being single core, even though it is actually dual core.
Also when shutting down or rebooting, it crashes on a blank screen after the progress bar is finished.
This results in failure to shut down or reboot.

Ricky Campbell (cyberdork33) wrote :

All these issues seem to affect all MacBook(Pro)5.x models, i.e. the new unibody aluminum MacBook and MacBook Pro included. (If someone can say differently, please do.)

Silvio Sisto (sistoviejo) wrote :

Just want to mention that MacBook5,1 seems to be able to boot Linux with ACPI enabled.
MacBook5,2 won't boot Linux unless you use the acpi=off option.
Again if someone can say differently, please do.

Ricky Campbell (cyberdork33) wrote :

Also, MacBookPro5,1 seems to need acpi=off from the posts in the forum. the MacBook5,1 may be the exception then.

Alex Murray (alexmurray) wrote :

My MacBookPro 5,1 with Intrepid boots and runs fine without acpi=off so at least for me this is not needed.

I can confirm the problem on my Macbook 5.2 with Ubuntu 8.10 Intrepid.

Changed in linux:
status: New → Confirmed
Changed in acpi:
status: New → Confirmed
Changed in mactel-support:
status: New → Confirmed
dentament (elledone) wrote :

Confirmed with macbook 5.2 with Ubuntu 8.10 and 9.04 beta.

Mike Arthur (mikearthur) wrote :

Has anyone raised this upstream on the kernel bugzilla?

I'm getting the same issues with the Debian kernel and also with a custom compiled vanilla one. If no-one else has pushed this upstream then I'll do it this weekend.

Mike Arthur (mikearthur) wrote :

For anyone interested there is/was also discussion on the linux-acpi mailing list here:
http://markmail.org/thread/x333am4rnnjud4op

Sadly there still seems to be no solution as of yet.

Silvio Sisto (sistoviejo) wrote :

> If no-one else has pushed this upstream then I'll do it this weekend.

I didn't post a bug report on the kernel bugzilla though.
You can go ahead and use this info on your report.

Sherry Howell (sherryhowell50) wrote :

confirmed this problem with macbook 5.2 on ubuntu 9.04, 8.10, debian lenny, and fedora 10.

Mike Arthur (mikearthur) wrote :

For a more preferential temporary workaround: use nosmp or maxcpus=1 to have ACPI but only one core enabled.

David Stansby (dstansby) on 2009-05-01
Changed in acpi:
importance: Undecided → Unknown
status: Confirmed → Unknown
Changed in acpi:
status: Unknown → Confirmed
Changed in acpi:
status: Confirmed → Incomplete
David Chan (blacksword-david) wrote :

Booting Xubuntu 9.04 is ok.

But when I boot ubuntu9.04 DVD.

System will be crashed.

I've tried several times by install macosx again and again with another dvd booting.

Every time, same.

Kẏra (kxra) wrote :

Seems this is still a bug in Karmic. It's odd that this is a known but that can be found in the forums and pretty much everywhere except the mactel community help pages on the ubuntu wiki

summary: Booting linux crashes on 2009 White Macbook (hardware version ID
- "MacBook5,2") unless you use acpi=off
+ "MacBook5,2") unless you use acpi=off or maxcpus=1
Silvio Sisto (sistoviejo) wrote :

The upstream kernel bug is currently in NEEDINFO status.
See here: http://bugzilla.kernel.org/show_bug.cgi?id=13170
Do you think you could be able to provide the requested information?

AlejandroV (lanjoe9) wrote :

Just a note on the "brightness not changing" bug: upon discussion with Julien Blache, the 'pommed' developer (the program to manage the special keys as well as some other sensors in apple hardware using GNU/Linux) it was concluded that this as a bug specific to the NVidia drivers:
http://lists.alioth.debian.org/pipermail/pommed-devel/2009-May/000051.html
http://lists.alioth.debian.org/pipermail/pommed-devel/2009-May/000055.html

As a workaround for the brightness problem: install pommed, and try switching to a text terminal with Fn+CTRL+ALT+F1, then adjust the brightness. Press Fn+CTRL+ALT+F7 (F6 through F9 depending on your distro) to go back to the graphics terminal.

If you find out it's eating your CPU let me know, I just realised I'm running my own patched version and not the one in the debian repos.

ste (dummy-it) wrote :

hi everybody.

I am able to boot ubuntu 9.04 on my Macbook White 5.2 using acpi (battery status, two cpu cores, etc..) booting from
rEFIt + grub-efi (compiled and installend in my OSX partition under the /EFI folder) with kernel option acpi=force,
instead of rEFIT + grub 2 standard (for which I need acpi=off in order to boot).

I don't know if it could help to locate the problem.

Silvio Sisto (sistoviejo) wrote :

ste,
I am not an expert in acpi. From your experience do you think this might be a kernel bug or a bug in grub? Sorry if this is an obvious question, I just thought I might throw this out there for people who know more about this to consider.

Ricky Campbell (cyberdork33) wrote :

It might even be a bug in Apple's emulation of the BIOS.

AlejandroV (lanjoe9) wrote :

hey Ste, can you share a bit more details on how you compiled grub-efi? which OS did you compile it in, which grub version did you use, which configure options and which options did you pass to mkimage-grub ? I've been spending about 5 endearing hours with grub 1.97beta4 and I can't get it to work properly yet..

Ricky Campbell (cyberdork33) wrote :

Check the following:

http://grub.enbug.org/TestingOnMacbook
http://grub.enbug.org/TestingOnEFI

There is also an exhaustive thread in the forum.

AlejandroV (lanjoe9) wrote :

Thank you for the links, however I tried those pages already and ended up with a grub-efi that doesn't understand the "linux" command (i.e. won't load the kernel). The farthest I've been able to go is using 1.97~beta3 and adding a few more modules than the ones suggested by the above pages to the grub-mkimage process, however now it complains about the 'search' command. I'm using the same grub.cfg that I used to boot off using grub-pc from Debian (v 1.97~beta3) so I don't see why it's not recognising the search or linux commands.

On the other hand, there are like 4 or 5 efi/macbook threads with 500+ posts on the ubuntu forums. I would really appreciate it if there was some more direct answer, if you know it of course..

here you are: http://ubuntuforums.org/showthread.php?p=6890723#post6890723

i am sturuko, this is a post of 03/2009. now i can use also Nvidia drivers
with all the 3d effects enabled, so I think points 1.b and 1.c are no more
useful now.

grub-efi was compiled in Ubuntu 8.10.. all the other info are in the link!

let me know if you succeed!

ste

On Sat, Oct 17, 2009 at 4:36 PM, AlejandroV <email address hidden> wrote:

> hey Ste, can you share a bit more details on how you compiled grub-efi?
> which OS did you compile it in, which grub version did you use, which
> configure options and which options did you pass to mkimage-grub ? I've
> been spending about 5 endearing hours with grub 1.97beta4 and I can't
> get it to work properly yet..
>
> --
> Booting linux crashes on 2009 White Macbook (hardware version ID
> "MacBook5,2") unless you use acpi=off or maxcpus=1
> https://bugs.launchpad.net/bugs/341230
> You received this bug notification because you are a direct subscriber
> of the bug.
>
> Status in Linux ACPI client: Incomplete
> Status in Mactel Support: Confirmed
> Status in “linux” package in Ubuntu: Confirmed
> Status in “linux-latest-2.6” package in Debian: New
>
> Bug description:
> Binary package hint: linux-image-2.6.27-11-generic
>
> The Macbook won't boot unless I use the acpi=off boot option.
>
> I am using Ubuntu 8.10 Intrepid Ibex with kernel 2.6.27.11 x86 generic.
> The machine's Hardware version id is Macbook5,2.
> It is one of the new early 2009 white macbooks with geforce 9400 video.
>
> I suspect this is the cause why Ubuntu won't show battery status and won't
> allow me to change screen brightness.
> I followed the steps described here [1] and was able to solve most problems
> (thanks!) with the exception of the previously mentioned.
>
> [1] https://help.ubuntu.com/community/MacBook5-1/Intrepid
> Note: Not sure if the package is the right one. If it is wrong please
> change it.
>
> ProblemType: Bug
> Architecture: i386
> DistroRelease: Ubuntu 8.10
> NonfreeKernelModules: nvidia
> Package: linux-image-2.6.27-11-generic 2.6.27-11.27
> ProcCmdLine: root=UUID=3f0132f8-e92c-4796-9721-768d4bbfa1f5 ro quiet splash
> acpi=off
> ProcEnviron:
>
> PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:/usr/games
> LANG=en_US.UTF-8
> SHELL=/bin/bash
> ProcVersionSignature: Ubuntu 2.6.27-11.27-generic
> SourcePackage: linux
>

ste (dummy-it) wrote :

On Thu, Oct 15, 2009 at 5:01 PM, Silvio Sisto <email address hidden> wrote:

> ste,
> I am not an expert in acpi.

neither do i..

> From your experience do you think this might be a kernel bug or a bug in
> grub? Sorry if this is an obvious question, I just thought I might throw
> this out there for people who know more about this to consider.
>
>
i think that this thing (that booting from grub-efi works fine with acpi
enabled) shuould be reported in the previously opened kernel bug.

AlejandroV (lanjoe9) wrote :

Thank you very much! Unfortunately I have the same problems even with the one you attached to the forum post :( it never "sees" the configfile, so it presents the command line and I have to give it the path to the configfile (for some reason it only was able to see inside the ext2 partition and not the osx one..). What version of MacOS do you have (could it perhaps be some change in the filesystem? I've got snow leopard)?

ste (dummy-it) wrote :

On Sun, Oct 18, 2009 at 3:13 AM, AlejandroV <email address hidden> wrote:

> Thank you very much! Unfortunately I have the same problems even with
> the one you attached to the forum post :( it never "sees" the
> configfile, so it presents the command line and I have to give it the
> path to the configfile (for some reason it only was able to see inside
> the ext2 partition and not the osx one..). What version of MacOS do you
> have (could it perhaps be some change in the filesystem? I've got snow
> leopard)?

mmm i've leopard (no snow), and osx has hfsplus as file system (here
grub-efi is installed), while in ubuntu i use ext3.
let me know if i could help you someway.

I've tried the following:

- Compile grub2 (in Ubuntu 9.04) using x86_64 with modules: acpi, boot, chain, configfile, ext2, fat, hfsplus, normal, part_gpt, sh
- Using kernel 2.6.28-16-generic
- Using NVIDIA drivers 173
- Using the posted grub.cfg updated to the above kernel version

rEFIt loads grub2 and from there I get (I think) all the way to X starting (it doesn't), at which point everything freezes. Help!?

ste (dummy-it) wrote :

try using nvidia drivers version 180.

i don't remember if i compiled grub2 using i386 or x86_64 platform..

ste

On Tue, Nov 3, 2009 at 7:32 AM, Andrew Cranwell
<email address hidden>wrote:

> I've tried the following:
>
> - Compile grub2 (in Ubuntu 9.04) using x86_64 with modules: acpi, boot,
> chain, configfile, ext2, fat, hfsplus, normal, part_gpt, sh
> - Using kernel 2.6.28-16-generic
> - Using NVIDIA drivers 173
> - Using the posted grub.cfg updated to the above kernel version
>
> rEFIt loads grub2 and from there I get (I think) all the way to X
> starting (it doesn't), at which point everything freezes. Help!?
>
> --
> Booting linux crashes on 2009 White Macbook (hardware version ID
> "MacBook5,2") unless you use acpi=off or maxcpus=1
> https://bugs.launchpad.net/bugs/341230
> You received this bug notification because you are a direct subscriber
> of the bug.
>
> Status in Linux ACPI client: Incomplete
> Status in Mactel Support: Confirmed
> Status in “linux” package in Ubuntu: Confirmed
> Status in “linux-latest-2.6” package in Debian: New
>
> Bug description:
> Binary package hint: linux-image-2.6.27-11-generic
>
> The Macbook won't boot unless I use the acpi=off boot option.
>
> I am using Ubuntu 8.10 Intrepid Ibex with kernel 2.6.27.11 x86 generic.
> The machine's Hardware version id is Macbook5,2.
> It is one of the new early 2009 white macbooks with geforce 9400 video.
>
> I suspect this is the cause why Ubuntu won't show battery status and won't
> allow me to change screen brightness.
> I followed the steps described here [1] and was able to solve most problems
> (thanks!) with the exception of the previously mentioned.
>
> [1] https://help.ubuntu.com/community/MacBook5-1/Intrepid
> Note: Not sure if the package is the right one. If it is wrong please
> change it.
>
> ProblemType: Bug
> Architecture: i386
> DistroRelease: Ubuntu 8.10
> NonfreeKernelModules: nvidia
> Package: linux-image-2.6.27-11-generic 2.6.27-11.27
> ProcCmdLine: root=UUID=3f0132f8-e92c-4796-9721-768d4bbfa1f5 ro quiet splash
> acpi=off
> ProcEnviron:
>
> PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:/usr/games
> LANG=en_US.UTF-8
> SHELL=/bin/bash
> ProcVersionSignature: Ubuntu 2.6.27-11.27-generic
> SourcePackage: linux
>

Using NVIDIA drivers 185 and fakebios option in grub.cfg - I now have ACPI (2 cores, battery status) and 3D effects! applesmc is not working, mouse key emulation has disappeared (not a bad thing, I have my F11/F12 keys back!) - thank you everyone! I'll double-check my grub.cfg and then post that and my build script.

Changed in acpi:
status: Incomplete → In Progress
Changed in acpi:
status: In Progress → Incomplete
Changed in acpi:
status: Incomplete → In Progress
Alex Murray (alexmurray) wrote :

To try and workaround the maxcpus=1 or noacpi, you could try the following kernel options instead:

acpi=noirq pnpacpi=off

which apparently have been successful in enabling a MacBook Air 2,1 to boot with full dual core cpu support and power management. (from: http://bloggis.se/atte/99928)

AlejandroV (lanjoe9) wrote :

@Alex Murray: the option doesn't seem to work on my macbook 5,2

OTOH, I finally managed to get ste's grub-efi working. I suspect it didn't work before because I had set the OS X partition to be "case sensitive". Some other programs on OSX fail to work with this setting as well, so I would suggest creating only the most common type of hfsplus partition.

Kẏra (kxra) wrote :

acpi=noirq pnpacpi=off

no longer works in lucid (though i've never tried it before)

David Stansby (dstansby) wrote :

This is still a problem when booting from 2.6.35

clemare (clemare-yahoo) wrote :

Ubuntu 10.10. Still not working

I've got Ubuntu 10.10 (2.6.35-23-generic #41-Ubuntu SMP) booting using my old grub 1.97 (that was booting Ubuntu 9.04) compiled as so:

./configure --with-platform=efi --target=x86_64
make
./grub-mkimage -d . -o grub.efi acpi boot chain configfile ext2 fat hfsplus normal part_gpt sh

Then my grub.cfg has

menuentry "linux latest" {
  root=(hd0,3)
  fakebios
  linux /vmlinuz root=/dev/sda3 video=efifb agp=off acpi=force
  initrd /initrd.img
}

I've got 2 CPUs, ACPI (sleep, reboot, poweroff, battery/power) - my next step will be to try a newer version of grub2.

David Stansby (dstansby) wrote :

Please could you forward that information to the upstream tracker at http://bugzilla.kernel.org/show_bug.cgi?id=13170

I also have a MacBook 5,2 (early 2009) and I experience the same errors than you do. This has been tested on Ubuntu 10.10

I managed to build a grub2 1.99rc1 x86_64-efi.
I had to do some tweaks to make some progress. I'm hacking directly in grub.cfg but from now, I don't care, I just want to test. So here is my entry :
menuentry 'Ubuntu, with Linux 2.6.35-25-generic' --class ubuntu --class gnu-linux --class gnu --class os {
        insmod part_gpt
        insmod ext2
        set debug=video
        insmod efi_gop
        set root='(hd0,gpt3)'
        search --no-floppy --fs-uuid --set=root d5175c18-7da2-49a9-a3af-844bad27c91d
        linux /boot/vmlinuz-2.6.35-25-generic root=UUID=d5175c18-7da2-49a9-a3af-844bad27c91d ro
        initrd /boot/initrd.img-2.6.35-25-generic
}

The options are pretty much the same than the ones from my working grub (with maxcpus=1).

At my first boot, I got "error: no argument specified". From what I've seen on the internet, it's because the syntax is different between Grub 1.98 and 1.99rc1. In 1.98 it's --set d5175c18... while --set=root is needed for 1.99rc1. However, this error wasn't a real problem because we're asked to press a key and then the boot continues.

It continues until the second error: "error: no suitable mode found". I've resolved this error by putting "set debug=video" and "insmod efi_gop" in my grub entry.

From this point, I can see that the kernel starts booting until the error I now have which I haven't solved yet : "fb: conflicting fb hw usage nouveaufb vs EFI VGA - removing generic driver".

I hope this post will help some of you to make some progress until the point I've reached.

I also tried what post #41 detailed but I have the very same error : conflicting fb...

I now have newer informations.

I've been able to boot on Ubuntu 10.10 64 bits with Grub-EFI and Nouveau involved but it needs a 2.6.38.2 (at least, it's the one I have tested). I couldn't make it work with the 2.6.35.

I now have 2 cores.

If you want to stick with the 2.6.35, I've been able to have the 2 cores but with the Nvidia Binary. And with this latter, to change the brightness is a pain.

To sum up :

refit + grub-pc + nouveau => works if maxcpus=1 as a grub option.
refit + grub-efi + nouveau => doesn't work. Can't boot.
refit + grub-efi + nvidia binary => works and you have 2 cores, 3D and compiz effect but it's a real pain to change the brightness plus it's a blob.
refit + grub-efi + nouveau WITH a kernel at least 2.6.38 => works like a charm : 2 cores, 2D and you can change easily the brightness

I hope this can help some of you.

This bug was filed against a series that is no longer supported and so is being marked as Won't Fix. If this issue still exists in a supported series, please file a new bug.

This change has been made by an automated script, maintained by the Ubuntu Kernel Team.

Changed in linux (Ubuntu):
status: Confirmed → Won't Fix
Changed in acpi:
status: In Progress → Expired
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers

Remote bug watches

Bug watches keep track of this bug in other bug trackers.